import { GunGraphConnector } from "./GunGraphConnector";
import { GunEvent } from "./GunEvent";
export declare class WebSocketGraphConnector extends GunGraphConnector {
    url: string;
    isConnected: boolean;
    events: {
        msgIn: GunEvent<GunMsg, string>;
        msgOut: GunEvent<GunMsg, string>;
        connection: GunEvent<boolean>;
    };
    private _pingInterval?;
    private _ws;
    private _requests;
    private _requestsBySoul;
    private _puts;
    private _queuedMessages;
    constructor(url: string, WS?: {
        new (url: string, protocols?: string | string[] | undefined): WebSocket;
        prototype: WebSocket;
        readonly CLOSED: number;
        readonly CLOSING: number;
        readonly CONNECTING: number;
        readonly OPEN: number;
    });
    request(souls: string[]): void;
    put(data: GunGraphData, ackEvt?: GunEvent): void;
    private onSocketConnect;
    private onSocketDisconnect;
    private _send;
    private _onReceiveMessage;
    private _onReceiveSocketData;
}
